#pragma once
#include "../tpl/smart_ptr_vector.h"
#include "../SerializeBase.h"
#include "Archive.h"
namespace Themis {

/**
 * CArchive ̏WǗIuWFNg
 */
class CArchiveLoader : public ISerializable {
public:
    CArchiveLoader(const ArchiveOwner& owner);
    ~CArchiveLoader();

    /// ꎞtH_̐ݒ
    void SetTempDir(const CFileName& o);

    /// ɂSĕ
    void Clear();
    /// oFileNameɂȂt@CXg쐬trueԂ
    bool Add(const CFileName& oFileName, vector<CArchive::SFileInfo>& vctFiles);
    /// ǂݍ߂鏑ɂȂtrue
    bool IsReadable(const CFileName& oFileName);

    /// ɉ𓀃tÕZbg
    void ResetExtractFlags();

    /// w肳ꂽViewNameɑΉt@Cǂ̏ɂ̂ǂɂ邩TBNULL-1
    pair<std::tr1::weak_ptr<CArchive>, int> Find(const string& strViewName) const {
        if (m_vctArchives.empty()) { // ɂȂꍇ͊ƑƎv̂ŒnɍœKĂ݂
            return pair<std::tr1::weak_ptr<CArchive>, int>(std::tr1::weak_ptr<CArchive>(), -1);
        }
        return InnerFind(strViewName);
    }

    //@{ SerializegȂꍇp̓Ԃ̕ۑE
    int GetCount() const { return int(m_vctArchives.size()); }
    string GetFileName(int i);
    void AddFileName(const CFileName& fileName);
    //@}

    /// e|tH_̎擾
    const CFileName& GetTempDir();

private:
    pair<std::tr1::weak_ptr<CArchive>, int> InnerFind(const string& strViewName) const;
    void OnSerialize(ISerializer& r) const;
    void OnRestore(IRestorer& r);

private:
    ArchiveOwner owner;

    boost::ptr_deque<CTempDir> m_vctTempDir; //ꎞtH_
    smart_ptr_vector<CArchive> m_vctArchives;
};

}
