#pragma once
#include "../Factory.h"
#include "../SPI.h"
#include "CommonArchiverDll.h"
namespace Themis {

/**
    pX[h₢킹pR[obN

    /// ɂ̃pX[h₢킹B
    bool QueryPassword(string& pass, int tryCount);
*/
class IQueryArchivePassword {
public:
    virtual ~IQueryArchivePassword() {}
    /// pX[h̎擾BLZfalseԂBtryCount0n߂ĂP₵Ă
    virtual bool QueryPassword(const CFileName& archiveName, string& pass, int tryCount) = 0;
};

/**
    ɓǂݍ݃IuWFNg̊NXB

    ǂݍ݂A[JCo[Ƃ͌ȂǁA
    SPÎƂAImageLoaderƔ薼OȂ肷̂ŁBB

    ̃fBNgƂ͖ႤŁB

@code

    virtual vector<string> InnerGetSupportedSuffixes() const;
    virtual bool InnerOpen(vector<SFile>& rList);
    virtual void InnerExtractFile(int nFileIndex, const CFileName& oDirName);
    virtual void InnerLoadFile(int nFileIndex, vector<uint8_t>& vctData);
    virtual bool InnerIsLoadable() const { return true; }

@endcode

*/
class IArchiver : private boost::noncopyable {
public:
    struct SFile {
        string  strName;        // t@C
        size_t  nOrgSize;       // WJ̃TCY
        FILETIME ftLastUpdate;  // ŏIXV
        SFile() {}
        SFile(const string& s, size_t n, const FILETIME& ft) : strName(s), nOrgSize(n), ftLastUpdate(ft) {}
        SFile(const Detail::INDIVIDUALINFO& ii);
    };

    IArchiver() : m_pQueryPass(NULL) {}
    virtual ~IArchiver() {}

    /// gq̃`FbN
    vector<string> GetSupportedSuffixesLc() const;

    //@{ ɂJ
    void Open(const CFileName& oFileName);
    bool OpenNoThrow(const CFileName& oFileName);
    //@}

    /// Ƀt@C̎擾
    const string& GetName() const { return m_strFileName; }
    /// t@C̎擾
    int GetFileCount() const { return static_cast<int>(m_vctFileList.size()); }
    /// t@C̎擾
    const string& GetFileName(int nFileIndex) const { return m_vctFileList[nFileIndex].strName; }
    /// t@CTCY̎擾
    size_t GetFileSize(int nFileIndex) const { return m_vctFileList[nFileIndex].nOrgSize; }
    /// t@C̍ŏIXV擾
    FILETIME GetLastUpdate(int nFileIndex) { return m_vctFileList[nFileIndex].ftLastUpdate; }

    /// ܂Ƃ߂ĉ𓀁BhwndParent != ȂvOX\B
    void ExtractAll(const CFileName& oDirName, bool showProgress = NULL);
    /// nFileIndexԖڂ̃t@CoDirNameɏo
    void ExtractFile(int nFileIndex, const CFileName& oDirName) { CheckBadArchive(nFileIndex); InnerExtractFile(nFileIndex, oDirName); }
    /// nFileIndexԖڂ̃t@Cvct֓ǂݍ
    void LoadFile(int nFileIndex, vector<uint8_t>& vctData) { return InnerLoadFile(nFileIndex, vctData); }

    enum EType {
        eTypeNormal,    // \bh(t@CAkĂ鏑)ł͂ȂAڃ։𓀂oȂꍇ(RarƂ)
        eTypeSolid,     // \bh(ۂ)ꍇ
        eTypeLoadable,  // \bhɂł͂ȂAڃ֓ǂݍݏoꍇ
    };
    /// ɂ̎ނԂ
    EType GetType() const { return InnerGetType(); }

    /// ɓt@CCfbNX̎擾BȂ-1
    int Find(const string& strFileName) const;

    /// pX[h₢킹IuWFNgZbg
    void SetQueryPass(IQueryArchivePassword* p) { m_pQueryPass = p; }

protected:
    /// InnerExtractFile() ēǂݍ
    void ExtractLoad(int nFileIndex, vector<uint8_t>& vctData);
    /// InnerLoadFile() ďo
    void LoadExtract(int nFileIndex, const CFileName& oDirName);

    /// pX[h̖₢킹sBIuWFNgLZꂽfalse
    bool QueryPassword(string& pass, int tryCount) {
        return m_pQueryPass != NULL ? m_pQueryPass->QueryPassword(CFileName(GetName()), pass, tryCount) : false;
    }

private:
    void CheckBadArchive(int nFileIndex);
    virtual vector<string> InnerGetSupportedSuffixes() const = 0;
    virtual bool InnerOpen(vector<SFile>& rList) = 0;
    virtual void InnerExtractAll(const CFileName& oDirName, bool showProgress) { throw RuntimeException(L""); }
    virtual void InnerExtractFile(int nFileIndex, const CFileName& oDirName) = 0;
    virtual void InnerLoadFile(int nFileIndex, vector<uint8_t>& vctData) = 0;
    virtual EType InnerGetType() const = 0;
    string              m_strFileName;
    vector<SFile>       m_vctFileList;
    IQueryArchivePassword* m_pQueryPass;
};


/**
    ɓǂݍ݃NXB

    CImageLoaderƓ悤FactoryListāA
    ǂݍ߂郂mœǂݍފB

    AA[JCo[DLL͂t@CJ
    \xȂႤɂȂ񂩌F肷鎖邩A
    ǂݍ߂邩ǂ̔ʂɂ͊gqĂɂƂB
    SPI͎̕ۂɓǂݍŔʂB

    RsypTv
@code

#include <Themis/Archiver.h>
#include <Themis/Spi.h>

@endcode@code

    CArchiver::GetFactoryList().Add(new CZipArchiverFactory);
    CArchiver::GetFactoryList().Add(new CSpiArchiverFactory(CFileNameModuleDir(L"spi/")));
    CArchiver::GetFactoryList().Add(new CSpiArchiverFactory(CFileName(CSpi::GetInstallDir())));
    CArchiver::GetFactoryList().Add(new CUnZipArchiverFactory);
    CArchiver::GetFactoryList().Add(new CUnRarArchiverFactory);
    CArchiver::GetFactoryList().Add(new CUnLhaArchiverFactory);
    CArchiver::GetFactoryList().Add(new GcaArchiverFactory);

@endcode
*/
class CArchiver : private boost::noncopyable {
public:
    CArchiver();
    ~CArchiver();

    /// WJɑΉĂ鏑ɂۂgq̃Xg擾
    static vector<string> GetSupportedSuffixesLc();

    /// ɂJBꂪΈȉ̊֐g悤ɂȂB
    void Open(const CFileName& oFileName);

    /// Ƀt@C̎擾
    const string& GetName() const { return m_pArchiver->GetName(); }
    /// t@C̎擾
    int GetFileCount() const { return m_pArchiver->GetFileCount(); }
    /// t@C̎擾
    const string& GetFileName(int nFileIndex) const { return m_pArchiver->GetFileName(nFileIndex); }
    /// t@CTCY̎擾
    size_t GetFileSize(int nFileIndex) const { return m_pArchiver->GetFileSize(nFileIndex); }
    /// ŏIXV̎擾
    FILETIME GetLastUpdate(int nFileIndex) const { return m_pArchiver->GetLastUpdate(nFileIndex); }

    /// ܂Ƃ߂ĉ𓀁BhwndParent != ȂvOX\B
    void ExtractAll(const CFileName& oDirName, bool showProgress = NULL)  { m_pArchiver->ExtractAll(oDirName, showProgress); }
    /// nFileIndexԖڂ̃t@CoDirNameɏo
    void ExtractFile(int nFileIndex, const CFileName& oDirName) { m_pArchiver->ExtractFile(nFileIndex, oDirName); }
    /// nFileIndexԖڂ̃t@Cvct֓ǂݍ
    void LoadFile(int nFileIndex, vector<uint8_t>& vct) { return m_pArchiver->LoadFile(nFileIndex, vct); }

    /// ɂ̎ނԂ
    IArchiver::EType GetType() const { return m_pArchiver->GetType(); }

    /// ɓt@CCfbNX̎擾BȂ-1
    int Find(const string& strFilename) const { return m_pArchiver->Find(strFilename); }

    /// pX[h₢킹IuWFNgZbg
    void SetQueryPass(IQueryArchivePassword* p) { m_pArchiver->SetQueryPass(p); }

    /// OpenfactorỹXg
    static FactoryList<IArchiver>& GetFactoryList();

private:
    std::tr1::shared_ptr<IArchiver> m_pArchiver;
};

}
