/** @file
 * GfB^ȂǂUndo/RedopNXB
 *
 * @author aki.
 */
#pragma once
namespace Themis {

/**
    R}h̊NXB

    hNX́AhLgIuWFNgւ̎QƂA
    KvɉExecute/Undo̎ɕKvȃf[^B

    g͂̔hNXāACX^X
    R}h̎sCommandBuffer֓ĂłB

    virtual void Execute();
    virtual void Undo();
    virtual void Redo();
*/
class ICommand : private boost::noncopyable {
public:
    virtual ~ICommand() {}
    /// s
    virtual void Execute() = 0;
    /// 蒼
    virtual void Undo() = 0;
    /// Ďs
    virtual void Redo() = 0;
};

/**
    ICommandǗB

    Undo/RedoȂǂsoB
    obt@TCYO̓TCYB(gpʂ|)

    Undo() / Redo()Ƃ́A
    K IsUndoable() / IsRedoable()`FbNĂB
*/
class CCommandBuffer : private boost::noncopyable {
public:
    CCommandBuffer(size_t nBufferSize = 0) : m_nBufferSize(nBufferSize) {
        m_itUndo = m_oBuffer.end();
    }
    ~CCommandBuffer() {
    }

    /// obt@̃TCY擾
    size_t GetBufferSize() const { return m_nBufferSize; }
    /// obt@̃TCYύX
    void SetBufferSize(size_t n) {
        m_nBufferSize = n;
        if (n < m_oBuffer.size()) {
            Clear(m_oBuffer.size() - n);
        }
    }

    /// s
    void Execute(const std::tr1::shared_ptr<ICommand>& pCommand) {
        pCommand->Execute();
        if (m_itUndo != m_oBuffer.end()) {
            m_oBuffer.erase(m_itUndo, m_oBuffer.end()); //UndoĂ͎̂Ă
        }
        m_oBuffer.push_back(pCommand);
        if (0 < m_nBufferSize && m_nBufferSize < m_oBuffer.size()) {
            m_oBuffer.pop_front();  //obt@̃TCY
        }
        m_itUndo = m_oBuffer.end();
    }

    /// 蒼ô
    bool IsUndoable() const { return (m_itUndo != m_oBuffer.begin()); }
    /// ɖ߂̂
    bool IsRedoable() const { return (m_itUndo != m_oBuffer.end()); }
    /// 蒼
    void Undo() { (*--m_itUndo)->Undo(); }
    /// ɖ߂
    void Redo() { (*m_itUndo++)->Redo(); }

    /// Sď
    void Clear() { m_oBuffer.clear();  m_itUndo = m_oBuffer.end(); }

    /// Ân
    void Clear(size_t n) {
        if (n <= m_oBuffer.size()) {
            TCommandList::iterator it = m_oBuffer.begin();
            for (size_t i=0; i < n; i++) { it++; }
            m_oBuffer.erase(m_oBuffer.begin(), it);
        }
    }

private:
    typedef std::list<std::tr1::shared_ptr<ICommand> > TCommandList;
    TCommandList            m_oBuffer;
    size_t                  m_nBufferSize;
    TCommandList::iterator  m_itUndo;    //undopCe[^
};

}
