#pragma once
#include "Encoder.h"
#include "Storage.h"
#include "Value.h"
namespace Themis {

/*
    CConfigƎ悤ȃNXB
    ׂC^[tF[XɈāA
    xɈڍŝ͑ςƎv̂ŁA΂炭CConfig2ɂƂāA
    ڍs CConfig ɈꊇuׂB
*/


/**
    CConfigT ́A typedef CStorage  m_oStorage; ĈϏӂ肾
    g񂹂悤Ƀx[XNXƂĎB
*/
template<class _CStorage> class CConfigTBase : private boost::noncopyable {
public:
    typedef _CStorage CStorage;
    typedef typename CStorage::TName TName;
    typedef typename CStorage::TData TData;
    typedef typename CStorage::TNameParam TNameParam;
    typedef typename CStorage::TDataParam TDataParam;
    //@{ RXgN^BCStorage֓nB
    inline CConfigTBase() {}
    template<class A> inline CConfigTBase(A a) : m_oStorage(a) {}
    template<class A, class B> inline CConfigTBase(A a, B b) : m_oStorage(a, b) {}
    template<class A, class B, class C> inline CConfigTBase(A a, B b, C c) : m_oStorage(a, b, c) {}
    template<class A, class B, class C, class D> inline CConfigTBase(A a, B b, C c, D d) : m_oStorage(a, b, c, d) {}
    //@}
    /// fXgN^BB
    inline ~CConfigTBase() {}
    /// Ɏ擾(Ϗ邾)
    inline TData Get(TNameParam oName) const { return GetStorage().Get(oName); }
    /// ɐݒ(Ϗ邾)
    inline void Set(TNameParam oName, TDataParam oValue) { GetStorage().Set(oName, oValue); }
    //@{ StorageIuWFNg̎擾
    inline CStorage& GetStorage() { return m_oStorage; }
    inline const CStorage& GetStorage() const { return m_oStorage; }
    //@}
private:
    CStorage  m_oStorage;
};


/**
    CConfigStorageȂǂStorageA
    gփC^[tF[X񋟂B

    StoragepĂ܂ΈϏƂvC邪A܂蒼IłȂ̂ł߂ƂB

    f[^^Cv𑝂₷ꍇÃNXpāA
    Num() ȂǂQlɊ֐ǉ邩A
    ۂƃRsyďׂB
*/
template<class CStorage = CConfigStorage> class CConfigT : public CConfigTBase<CStorage> {
public:
    //@{ RXgN^BL̂CStorage֓nB
    inline CConfigT() {}
    template<class A> inline CConfigT(A a) : CConfigTBase<CStorage>(a) {}
    template<class A, class B> inline CConfigT(A a, B b) : CConfigTBase<CStorage>(a, b) {}
    template<class A, class B, class C> inline CConfigT(A a, B b, C c) : CConfigTBase<CStorage>(a, b, c) {}
    template<class A, class B, class C, class D> inline CConfigT(A a, B b, C c, D d) : CConfigTBase<CStorage>(a, b, c, d) {}
    //@}
    /// fXgN^BB
    inline ~CConfigT() {}

    //@{ ef[^^Cv̒l̎擾EݒB
    inline CConfigValue<CStorage, CConfigNumEncoder> Num(TNameParam oName) {
        return CConfigValue<CStorage, CConfigNumEncoder>(GetStorage(), oName);
    }
    inline CConfigValue<CStorage, CConfigBoolEncoder> Bool(TNameParam oName) {
        return CConfigValue<CStorage, CConfigBoolEncoder>(GetStorage(), oName);
    }
    inline CConfigValue<CStorage, CConfigFloatEncoder> Float(TNameParam oName) {
        return CConfigValue<CStorage, CConfigFloatEncoder>(GetStorage(), oName);
    }
    inline CConfigValue<CStorage, CConfigBinEncoder> Bin(TNameParam oName) {
        return CConfigValue<CStorage, CConfigBinEncoder>(GetStorage(), oName);
    }
    inline CConfigValue<CStorage, CConfigStrEncoder> Str(TNameParam oName) {
        return CConfigValue<CStorage, CConfigStrEncoder>(GetStorage(), oName);
    }
    inline CConfigValue<CStorage, CConfigPointEncoder> Point(TNameParam oName) {
        return CConfigValue<CStorage, CConfigPointEncoder>(GetStorage(), oName);
    }
    inline CConfigValue<CStorage, CConfigSizeEncoder> Size(TNameParam oName) {
        return CConfigValue<CStorage, CConfigSizeEncoder>(GetStorage(), oName);
    }
    inline CConfigValue<CStorage, CConfigRectEncoder> Rect(TNameParam oName) {
        return CConfigValue<CStorage, CConfigRectEncoder>(GetStorage(), oName);
    }
    inline CConfigValue<CStorage, CConfigColorEncoder> Color(TNameParam oName) {
        return CConfigValue<CStorage, CConfigColorEncoder>(GetStorage(), oName);
    }
    inline CConfigValue<CStorage, CConfigLineEncoder> Line(TNameParam oName) {
        return CConfigValue<CStorage, CConfigLineEncoder>(GetStorage(), oName);
    }
    //@}
    //@{ constŁBRsyēKconstǉB
    inline const CConfigValue<const CStorage, CConfigNumEncoder> Num(TNameParam oName) const {
        return CConfigValue<const CStorage, CConfigNumEncoder>(GetStorage(), oName);
    }
    inline const CConfigValue<const CStorage, CConfigBoolEncoder> Bool(TNameParam oName) const {
        return CConfigValue<const CStorage, CConfigBoolEncoder>(GetStorage(), oName);
    }
    inline const CConfigValue<const CStorage, CConfigFloatEncoder> Float(TNameParam oName) const {
        return CConfigValue<const CStorage, CConfigFloatEncoder>(GetStorage(), oName);
    }
    inline const CConfigValue<const CStorage, CConfigBinEncoder> Bin(TNameParam oName) const {
        return CConfigValue<const CStorage, CConfigBinEncoder>(GetStorage(), oName);
    }
    inline const CConfigValue<const CStorage, CConfigStrEncoder> Str(TNameParam oName) const {
        return CConfigValue<const CStorage, CConfigStrEncoder>(GetStorage(), oName);
    }
    inline const CConfigValue<const CStorage, CConfigPointEncoder> Point(TNameParam oName) const {
        return CConfigValue<const CStorage, CConfigPointEncoder>(GetStorage(), oName);
    }
    inline const CConfigValue<const CStorage, CConfigSizeEncoder> Size(TNameParam oName) const {
        return CConfigValue<const CStorage, CConfigSizeEncoder>(GetStorage(), oName);
    }
    inline const CConfigValue<const CStorage, CConfigRectEncoder> Rect(TNameParam oName) const {
        return CConfigValue<const CStorage, CConfigRectEncoder>(GetStorage(), oName);
    }
    inline const CConfigValue<const CStorage, CConfigColorEncoder> Color(TNameParam oName) const {
        return CConfigValue<const CStorage, CConfigColorEncoder>(GetStorage(), oName);
    }
    inline const CConfigValue<const CStorage, CConfigLineEncoder> Line(TNameParam oName) const {
        return CConfigValue<const CStorage, CConfigLineEncoder>(GetStorage(), oName);
    }
    //@}
};

}
