#pragma once
#include "PlaneEx.h"
namespace Themis {

/**
    CPlaneEx̊֐̎ƁAŏʂWrbg̕sx֐ȂǁB(0x00A0xffs)
*/
class CPlane32 : public CPlaneEx {
public:
    CPlane32(const std::tr1::shared_ptr<IPlaneImpl>& pImpl) : CPlaneEx(pImpl, 32) {}

    virtual void ReverseFill(CRect rcDst);
    virtual void AlphaFill(COLORREF rgb, CRect rcDst, int nAlpha);
    virtual void SatAddFill(COLORREF rgb, CRect rcDst);
    virtual void SatSubFill(COLORREF rgb, CRect rcDst);
    virtual void MosaicFill(CRect rc, int nLevel);
    virtual void MosaicAverageFill(CRect rc, int nLevel);
    virtual void LevelRevTableFill(CRect rcDst, uint8_t anTable[0x100]);
    virtual void GrayFill(CRect rc);
    virtual void GrayFillStrict(CRect rc);
    virtual void MakeBargraph(CRect rcDst, double adData[], int nDataCount, double dDataMin, double dDataMax, COLORREF rgbBg);
    virtual void GetHistogram(int anHistogram[0x100], CRect rcSrc);
    virtual void GetHistogramRGBAverage(int anHistogram[0x100], CRect rcSrc);
    virtual void GetHistogramRGB(int anHistogramR[0x100], int anHistogramG[0x100], int anHistogramB[0x100], CRect rcSrc);
    virtual int GetColorCount(CRect rc);
    virtual COLORREF GetAverageColor(CRect rc);
    virtual void ClearAlpha();
    virtual void ReverseAlpha();
    virtual void BrightToAlpha();
    virtual void DiffToAlpha(const CPlane& rSrc);
    virtual void DiffToAlphaStrict(const CPlane& rSrc);
    virtual bool HasAlphaChannel(CRect rcDst);
    virtual void TableBlt(const CPlane8& rSrc, CPoint ptDst, CRect rcSrc, COLORREF rgbTable[0x100], const CClipper& rClip = CClipper());
    virtual void BltTrans(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, COLORREF rgbTrans, const CClipper& rClip = CClipper());
    virtual void BefogBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void SharpBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void HardSharpBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void GaussBefogBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double r, const CClipper& rClip = CClipper());
    virtual void UnsharpMaskBlt(const CPlane& rSrc, const CPlane& rMask, CPoint ptDst, CRect rcSrc, CPoint ptMask, const CClipper& rClip = CClipper());
    virtual void MedianFilterBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void BefogEdgeBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double dRate, const CClipper& rClip = CClipper());
    virtual void BefogNotEdgeBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double dRate, const CClipper& rClip = CClipper());
    virtual void EdgeBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double dRate, const CClipper& rClip = CClipper());
    virtual void ChannelMixerBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double rr, double rg, double rb, double gr, double gg, double gb, double br, double bg, double bb, const CClipper& rClip = CClipper());
    virtual void ChannelMixerBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double kr, double kg, double kb, const CClipper& rClip = CClipper());
    virtual void OrBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void AndBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void XorBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void SatAddBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void SatSubBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void FadeBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, int nFade, const CClipper& rClip = CClipper());
    virtual void BrightBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, int nBright, const CClipper& rClip = CClipper());
    virtual void AlphaBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, int nAlpha, const CClipper& rClip = CClipper());
    virtual void BlendBlt(const CPlane& rSrc, const CPlane& rSrc2, CPoint ptDst, CRect rcSrc, int nAlpha, const CClipper& rClip = CClipper());
    virtual void MaskBlt(const CPlane& rSrc, const CPlane8& rMask, CPoint ptDst, CRect rcSrc, int nLow, int nHigh, const CClipper& rClip = CClipper());
    virtual void MaskFadeBlt(const CPlane& rSrc, const CPlane8& rMask, CPoint ptDst, CRect rcSrc, int nBorder, int nVague, const CClipper& rClip = CClipper());
    virtual void MaskBrightBlt(const CPlane& rSrc, const CPlane8& rMask, CPoint ptDst, CRect rcSrc, int nBorder, int nVague, const CClipper& rClip = CClipper());
    virtual void MaskBlendBlt(const CPlane& rSrc, const CPlane& rSrc2, const CPlane8& rMask, CPoint ptDst, CRect rcSrc, int nBorder, int nVague, const CClipper& rClip = CClipper());
    virtual void BltAlpha(const CPlane32& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void StretchBltNearest(const CPlane& rSrc, CRect rcDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void StretchBlt(const CPlane& rSrc, CRect rcDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void StretchBltAlpha(const CPlane& rSrc, CRect rcDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void StretchBltPixelAveration(const CPlane& rSrc, CRect rcDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void StretchBltPixelAverationAlpha(const CPlane& rSrc, CRect rcDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void StretchBltLanczos3(const CPlane& rSrc, CRect rcDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void StretchBltLanczos3Alpha(const CPlane& rSrc, CRect rcDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void ClearTypeBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void MirrorHBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void MirrorVBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void Rot180Blt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void Rot90ClockwiseBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void Rot90AntiClockwiseBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    virtual void RotBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double dAngle, COLORREF rgbFill, const CClipper& rClip = CClipper());
    virtual void RotBltDraft(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double dAngle, COLORREF rgbFill, const CClipper& rClip = CClipper());
};



}
