#pragma once
#include "PlaneEx.h"
namespace Themis {

/** CPlaneExւ̃GtFNg`sNX

    CRect InnerRender(CPlaneEx& rDstPlane) const;

    RsypTv
@code

    m_pEffecter->Render(oDstPlane);
    if (!m_pEffecter->IsEnd()) {
        m_pEffecter->ToNextFrame();
    } else {
        //GtFNgIB
        //m_pEffecter.reset(); ƂB
    }

@endcode
*/
class CPlaneEffector : private boost::noncopyable {
public:
    CPlaneEffector(): m_nFrameCount(0), m_nMaxFrame(60) {}
    virtual ~CPlaneEffector() {}

    /// It[ݒ肷
    void SetMaxFrame(int nFrame) { m_nMaxFrame = nFrame; }
    /// GtFNg`̃t[擾
    int GetMaxFrame() const { return m_nMaxFrame; }

    /// Nbv̈ݒ
    void SetClip(const CRect& rc) { m_prcClip.reset(new CRect(rc)); }
    /// Nbv̈𖢐ݒɂ
    void ResetClip() { m_prcClip.reset(); }
    /// LȃNbv̈悪̂ǂ
    bool IsClip() const { return m_prcClip.get() != NULL; }
    /// Nbv̈̎擾
    const CRect& GetClip() const { return *m_prcClip; }

    /// ݂̃t[̃GtFNg̕`
    CRect Render(CPlaneEx& rDstPlane) const { return InnerRender(rDstPlane); }
    /// ݂̃t[ȑOŃGtFNg͏IĂtrue
    bool IsEnd() const { return m_nMaxFrame <= m_nFrameCount; }
    /// ̃t[
    void ToNextFrame() { Themis_DebugAssert(!IsEnd()); ++m_nFrameCount; }

protected:
    /// Nbv]̈쐬(dst:(0, 0)ցAsrc:(0, 0, szSrcPlane)]ꍇ)
    CRect GetClipedRect(const CSize& szSrcPlane) const {
        return IsClip()? CRect(szSrcPlane).GetIntersect(GetClip()): CRect(szSrcPlane);
    }
    /// ݂̃t[擾
    int GetFrameCount() const { return m_nFrameCount; }
    /// lȂǂ̎Zoɗp(OnRange̐`)
    int GetEffect(int nRange) const { return nRange * m_nFrameCount / m_nMaxFrame; }
    /// lȂǂ̎Zoɗp(nRangeO̐`)
    int GetEffectReverse(int nRange) const { return nRange - GetEffect(nRange); }

private:
    virtual CRect InnerRender(CPlaneEx& rDstPlane) const = 0;

private:
    auto_ptr<CRect>    m_prcClip;
    unsigned int            m_nFrameCount;
    unsigned int            m_nMaxFrame;
};

//////////////////////////////////////////////////////////////////////

class CPlaneEffectNoEffect : public CPlaneEffector {
public:
    CPlaneEffectNoEffect(CPlaneEx& r) : m_rSrc(r) {}
private:
    CRect InnerRender(CPlaneEx& rDstPlane) const;
    CPlaneEx&   m_rSrc;
};

/// tF[hAEg
class CPlaneEffectFadeOut : public CPlaneEffector {
public:
    CPlaneEffectFadeOut(CPlaneEx& r): m_rSrc(r) {}
private:
    CRect InnerRender(CPlaneEx& rDstPlane) const;
    CPlaneEx&   m_rSrc;
};

/// tF[hC
class CPlaneEffectFadeIn : public CPlaneEffector {
public:
    CPlaneEffectFadeIn(CPlaneEx& r): m_rSrc(r) {}
private:
    CRect InnerRender(CPlaneEx& rDstPlane) const;
    CPlaneEx&   m_rSrc;
};

/// zCgAEg
class CPlaneEffectWhiteOut : public CPlaneEffector {
public:
    CPlaneEffectWhiteOut(CPlaneEx& r): m_rSrc(r) {}
private:
    CRect InnerRender(CPlaneEx& rDstPlane) const;
    CPlaneEx&   m_rSrc;
};

/// zCgC
class CPlaneEffectWhiteIn : public CPlaneEffector {
public:
    CPlaneEffectWhiteIn(CPlaneEx& r): m_rSrc(r) {}
private:
    CRect InnerRender(CPlaneEx& rDstPlane) const;
    CPlaneEx&   m_rSrc;
};

/// NXtF[h
class CPlaneEffectCrossFade : public CPlaneEffector {
public:
    CPlaneEffectCrossFade(CPlaneEx& r, CPlaneEx& r2): m_rSrc(r), m_rSrc2(r2) {}
private:
    CRect InnerRender(CPlaneEx& rDstPlane) const;
    CPlaneEx&   m_rSrc;     //ꂩ
    CPlaneEx&   m_rSrc2;    //ɕς
};

/// UCN
class CPlaneEffectMosaic : public CPlaneEffector {
public:
    CPlaneEffectMosaic(CPlaneEx& r, CPlaneEx& r2): m_rSrc(r), m_rSrc2(r2) {}
private:
    CRect InnerRender(CPlaneEx& rDstPlane) const;
    CPlaneEx&   m_rSrc;     //ꂩ
    CPlaneEx&   m_rSrc2;    //ɕς
};

//////////////////////////////////////////////////////////////////////

/// }XNtF[hAEg
class CPlaneEffectMaskFadeOut : public CPlaneEffector {
public:
    CPlaneEffectMaskFadeOut(CPlaneEx& r, CPlane8& rm, int nVague)
        : m_rSrc(r), m_rMask(rm), m_nVague(nVague) {}
private:
    CRect InnerRender(CPlaneEx& rDstPlane) const;
    CPlaneEx&   m_rSrc;
    CPlane8&    m_rMask;
    int         m_nVague;
};

/// }XNtF[hC
class CPlaneEffectMaskFadeIn : public CPlaneEffector {
public:
    CPlaneEffectMaskFadeIn(CPlaneEx& r, CPlane8& rm, int nVague)
        : m_rSrc(r), m_rMask(rm), m_nVague(nVague) {}
private:
    CRect InnerRender(CPlaneEx& rDstPlane) const;
    CPlaneEx&   m_rSrc;
    CPlane8&    m_rMask;
    int         m_nVague;
};

/// }XNzCgAEg
class CPlaneEffectMaskWhiteOut : public CPlaneEffector {
public:
    CPlaneEffectMaskWhiteOut(CPlaneEx& r, CPlane8& rm, int nVague)
        : m_rSrc(r), m_rMask(rm), m_nVague(nVague) {}
private:
    CRect InnerRender(CPlaneEx& rDstPlane) const;
    CPlaneEx&   m_rSrc;
    CPlane8&    m_rMask;
    int         m_nVague;
};

/// }XNzCgC
class CPlaneEffectMaskWhiteIn : public CPlaneEffector {
public:
    CPlaneEffectMaskWhiteIn(CPlaneEx& r, CPlane8& rm, int nVague)
        : m_rSrc(r), m_rMask(rm), m_nVague(nVague) {}
private:
    CRect InnerRender(CPlaneEx& rDstPlane) const;
    CPlaneEx&   m_rSrc;
    CPlane8&    m_rMask;
    int         m_nVague;
};

/// }XNNXtF[h
class CPlaneEffectMaskCrossFade : public CPlaneEffector {
public:
    CPlaneEffectMaskCrossFade(CPlaneEx& r, CPlaneEx& r2, CPlane8& rm, int nVague)
        : m_rSrc(r), m_rSrc2(r2), m_rMask(rm), m_nVague(nVague) {}
private:
    CRect InnerRender(CPlaneEx& rDstPlane) const;
    CPlaneEx&   m_rSrc;     //ꂩ
    CPlaneEx&   m_rSrc2;    //ɕς
    CPlane8&    m_rMask;
    int         m_nVague;
};

}
