#pragma once
namespace Themis {

/**
    MD5̌vZB

    ̃\[XQlɂɃJX^}CYB
*/
class CMD5 : private boost::noncopyable {
public:
    //@{ 蔲p֐
    static string Make(const void* p, size_t n) {
        CMD5 md5;
        md5.Update(p, n);
        md5.Finalize();
        return md5.HexDigest();
    }
    static string Make(const vector<uint8_t>& vct) {
        CMD5 md5;
        md5.Update(vct);
        md5.Finalize();
        return md5.HexDigest();
    }
    //@}

    CMD5();
    ~CMD5();

    void Update(const void* p, size_t n);
    void Update(const std::string& data) {
        if (!data.empty()) {
            Update(data.c_str(), data.size());
        }
    }
    void Update(const vector<uint8_t>& data) {
        if (!data.empty()) {
            Update(&data[0], data.size());
        }
    }
    void Finalize();

    // digest as a 16-uint8_t binary array
    const uint8_t* Digest() const { return digest; }
    // digest as a 33-uint8_t ascii-hex string
    string HexDigest() const;

    // rB
    bool IsMatch(const string& strHexDigest);

private:
    uint32_t state[4];
    uint32_t bits[2];
    uint8_t buffer[64];
    uint8_t digest[16];
};

}
