#include "stdafx.h"
#include "MsgHook.h"
namespace Themis {

IMsgHooker::~IMsgHooker() {
 // single_list<CMsgHook*> t = m_oHookOwnerList;   //폜肳ꂽ₱ȂŁARs[Ƃ
    for (single_list<CMsgHook*>::iterator it = m_oHookOwnerList.begin(), itEnd = m_oHookOwnerList.end(); it != itEnd; ) {
        (*it++)->Remove(this);
    }
}

namespace {
    class CMsgHookInstanceCounter {
    public:
        CMsgHookInstanceCounter() : m_nMsgHookInstanceCount(0) {}
        ~CMsgHookInstanceCounter() {
            Themis_DebugAssert(m_nMsgHookInstanceCount == 0);
            //RɈĎ́ACMsgHookĂȂA
            //܂RemoveYĂIuWFNĝ\ƂƁB
            //ÃIuWFNgɉ̂IuWFNg
            //Remove\̂ŁAKYĂƂȂB
        }
        void Inc() { ++m_nMsgHookInstanceCount; }
        void Dec() { --m_nMsgHookInstanceCount; }
    private:
        int m_nMsgHookInstanceCount;
    };
    CMsgHookInstanceCounter& GetMsgHookInstanceCounter() {
        static CMsgHookInstanceCounter s;
        return s;
    }
}

CMsgHook::CMsgHook(): m_nDspatchDepth(0), m_bRemoved(false), mutex(new boost::recursive_mutex) {
    GetMsgHookInstanceCounter().Inc();
}

CMsgHook::~CMsgHook() {
    GetMsgHookInstanceCounter().Dec();
    Themis_DebugAssert(m_oList.empty());    //ȂȂ΃fXgN^Ă΂Ȃ͂
}

void CMsgHook::Add(IMsgHooker* pHook) {
    boost::recursive_mutex::scoped_lock lock(*mutex);
    // ̃XgHookerǉ
    m_oList.push_back(make_pair(pHook, true));
    // Hooker̃Xg֎ǉ
    pHook->m_oHookOwnerList.insert(this);
 // Themis_DebugAssert(p.second != false);  //d͋Ȃ
}

void CMsgHook::Remove(IMsgHooker* pHook) {
    // ̊֐͑rƃfbhbN
    // ̃XgHooker폜
    Themis_DebugAssert(!m_oList.empty());
    for (TList::iterator it = m_oList.begin(); it != m_oList.end(); ++it) {
        if ((*it).first == pHook) {
            (*it).second = false;   //ł̓tOZbg邾
            m_bRemoved = true;
            break;  //d͋ĂȂ̂Łc
        }
    }
    Themis_DebugAssert(m_bRemoved != false);    //o^ĂȂ̂폜悤ƂH
    // Hooker̃Xg玩폜
    pHook->m_oHookOwnerList.erase(this);
    // ɃbZ[WsĂȂꍇłƂȂƉiɏoȂB
    Garbage();
}

bool CMsgHook::Dispatch(CMsgHookPrms& rPrms) {
    bool bDisp = false;
    {
        boost::recursive_mutex::scoped_lock lock(*mutex);
        rPrms.m_pOwner = this;
        ++m_nDspatchDepth;
        try {
         // for (TList::iterator it = m_oList.begin(); it != m_oList.end(); ++it) {
            for (size_t i = 0, n = m_oList.size(); i < n; i++) {
             // const pair<IMsgHooker*, bool>& r = *it;
                const pair<IMsgHooker*, bool>& r = m_oList[i];
                if (r.second) {
                    IMsgHooker* p = r.first;
                    if (p->HookMsg(rPrms)) {
                        bDisp = true;
                    }
                }
            }
        } catch (...) {
            --m_nDspatchDepth;
            rPrms.m_pOwner = NULL;
            throw;
        }
        --m_nDspatchDepth;
        rPrms.m_pOwner = NULL;
    }
    Garbage();
    return bDisp;
}

namespace { struct IsSecondFalse { template<class T> inline bool operator()(const T& r) { return !r.second; } }; }
/// 폜tÔHookerXg폜AXgȂdelete this
void CMsgHook::Garbage() {
    if (m_bRemoved && m_nDspatchDepth == 0) {
        //delete thisUnlock̂ŁA܂ŉ̂Ȃ悤ɎQƃJEg𑝂₵ĂLock
        std::tr1::shared_ptr<boost::recursive_mutex> mtx = mutex;
        boost::recursive_mutex::scoped_lock lock(*mtx);
        //tO̗ĂȂHookerXg폜
        m_oList.erase(std::remove_if(m_oList.begin(), m_oList.end(), IsSecondFalse()), m_oList.end());
        m_bRemoved = false;
        if (m_oList.empty()) {
            delete this;
        }
    }
}

}
