#include "stdafx.h"
#include <math.h>
#include "MsgHook.h"
#include "Region.h"
namespace Themis {

CRegion::CRegion(const CRegion& r) {
    m_hRgn = CreateRectRgn(0, 0, 0, 0);
    int n = ::CombineRgn(m_hRgn, r.m_hRgn, NULL , RGN_COPY);
    if (n == ERROR) {
        throw Win32Exception(L"[W̕Ɏs܂");
    }
}

CRegion& CRegion::operator=(const CRegion& oSrc) {
    Delete();
    m_hRgn = CreateRectRgn(0, 0, 0, 0);
    int n = ::CombineRgn(m_hRgn, oSrc.m_hRgn, NULL , RGN_COPY);
    if (n == ERROR) {
        throw Win32Exception(L"[W̕Ɏs܂");
    }
    return *this;
}

void CRegion::Create(HDC hDC, const CRect& rc, COLORREF rgbTrans) {
    Delete();
    ::BeginPath(hDC);
    CRect rcDst = rc;
    for (int y=rc.left; y<rc.right; y++) {
        for (int x=rc.top; x<rc.bottom; x++) {
            if (::GetPixel(hDC, x, y) != rgbTrans) {
                int nBeginX = x;
                for (; x<rc.bottom; x++) {
                    //ߐF甲
                    if (::GetPixel(hDC, x, y) == rgbTrans)
                        break;
                }
                //[vfoȑŔƂłAx == rc.bottom
                //int nEndX = x-1;
                int nEndX = x;   //I_͕`悳Ȃ
                ::MoveToEx(hDC, nBeginX, y, NULL);
                ::LineTo(hDC, nEndX, y);
                ::LineTo(hDC, nEndX, y+1); //炵ĎOp`ɁB
                if (::CloseFigure(hDC) == FALSE)
                    throw Win32Exception(L"[W̍쐬Ɏs܂");
            }
        }
    }
    ::EndPath(hDC);
    m_hRgn = ::PathToRegion(hDC);
    if (m_hRgn == NULL) {
        throw Win32Exception(L"[W̍쐬Ɏs܂");
    }
}

void CRegion::Create(CPoint pt[], int ptNum) {
    Delete();
    m_hRgn = ::CreatePolygonRgn(pt, ptNum, WINDING);
    if (m_hRgn == NULL) {
        throw Win32Exception(L"[W̍쐬Ɏs܂");
    }
}

void CRegion::CreateAlternate(CPoint pt[], int ptNum) {
    // CreatêALTERNATEɂB
    Delete();
    m_hRgn = ::CreatePolygonRgn(pt, ptNum, ALTERNATE);
    if (m_hRgn == NULL) {
        throw Win32Exception(L"[W̍쐬Ɏs܂");
    }
}

void CRegion::CreateStar(const CPoint& rCenter, int r) {
    const double dPi = 3.1415926535897932384626433832795;
    CPoint apt[5];
    for (int i=0; i<5; i++) {
        apt[i].x = rCenter.x + static_cast<int>(::sin(2 * dPi / 5) * r);
        apt[i].y = rCenter.y + static_cast<int>(::cos(2 * dPi / 5) * r);
    }
    return Create(apt, 5);
}

void CRegion::CreateCircle(const CPoint& ptCenter, int pr) {
    CRect rc;
    rc.left = ptCenter.x - pr;
    rc.right = ptCenter.x + pr;
    rc.top = ptCenter.y - pr;
    rc.bottom = ptCenter.y + pr;
    CreateEllipse(rc);
}

void CRegion::CreateEllipse(const CRect& rc) {
    Delete();
    m_hRgn = ::CreateEllipticRgnIndirect(&rc);
    if (m_hRgn == NULL) {
        throw Win32Exception(L"[W̍쐬Ɏs܂");
    }
}

void CRegion::Delete() {
    if (m_hRgn != NULL) {
        ::DeleteObject(m_hRgn);
        m_hRgn = NULL;
    }
}

CRegion& CRegion::operator+=(const CRegion& oSrc) {
    HRGN hDst = m_hRgn;
    HRGN hSrc = oSrc.m_hRgn;
    if (hDst == NULL || hSrc == NULL)
        return *this;
    int n = ::CombineRgn(hDst, hDst, hSrc, RGN_OR);
    if (n == ERROR) {
        throw Win32Exception(L"[W̉ZɎs܂");
    }
    return *this;
}

CRegion& CRegion::operator-=(const CRegion& oSrc) {
    HRGN hDst = m_hRgn;
    HRGN hSrc = oSrc.m_hRgn;
    if (hDst == NULL || hSrc == NULL)
        return *this;
    int n = ::CombineRgn(hDst, hDst, hSrc, RGN_DIFF);
    if (n == ERROR) {
        throw Win32Exception(L"[W̌ZɎs܂");;
    }
    return *this;
}

void CRegion::SetToWindow(HWND hWnd) {
    if (m_hRgn != NULL) {
        //Rs[쐬
        HRGN hRgn = CreateRectRgn(0, 0, 0, 0);
        int n = ::CombineRgn(hRgn, m_hRgn, NULL , RGN_COPY);
        if (n == ERROR) {
            throw Win32Exception(L"[W̕Ɏs܂");
        }
        //֐ݒ
        if (::SetWindowRgn(hWnd, hRgn, TRUE) == 0) {
            throw Win32Exception(L"EBhEւ̃[W̐ݒɎs܂");
        }
    } else {
        if (::SetWindowRgn(hWnd, NULL, TRUE) == 0) {
            throw Win32Exception(L"EBhẼ[W̎OɎs܂");
        }
    }
}

////////////////////////////////////////////////////////////////////////////////

CRegionHooker::CRegionHooker(CRegion& rRegion, HWND hWnd, CMsgHook& rMsgHook, const std::tr1::shared_ptr<IOwner>& pOwner): m_pOwner(pOwner) {
    rMsgHook.Add(this);
    rRegion.SetToWindow(hWnd);
}

CRegionHooker::~CRegionHooker() {
}

bool CRegionHooker::HookMsg(CMsgHookPrms& rPrms) {
    if (rPrms.GetMsg() == WM_NCHITTEST) {
        CPoint pt;
        ::GetCursorPos(&pt);
        ::ScreenToClient(rPrms.GetWnd(), &pt);      // NCAgW
        if (m_pOwner->IsDraggable(pt)) {                      // hbOĂ̂[H
            rPrms.SetResult(HTCAPTION);             // ^Cgo[NbNƂɂ
            return true;
        }
    }
    return false;
}

}
