#include "stdafx.h"
#include "Encoding.h"
#include <windows.h> // MultiByteToWideChar
#include <locale>
#include <sstream> // ostringstream
namespace Themis {

//#define Themis_UseStdLocale

namespace {
    static std::locale& GetLocale() {
        static std::locale loc("");
        return loc;
    }

    static bool InitializeLocale() {
        int result = _configthreadlocale(_DISABLE_PER_THREAD_LOCALE); // ftHgŃRȂ͂Ô߁BB
        BOOST_ASSERT(result != -1);
        std::locale::global(GetLocale());
        return true;
    }

    static volatile bool localeInitialized = InitializeLocale();
}

void EncodingInitializeLocale() {
  #if 0
    InitializeLocale();
  #endif
  #if 0
  #ifndef NDEBUG
    // ǂVC++2008ɂȂĂboost::thread̉[ŃoÔŃ_~[ĂяoĂ݂B_no
    std::ostringstream() << "";
  #endif
  #endif
}

Encoding::Encoding() {
}

string Encoding::GetString(const std::string& bytes, int index, int count) const {
    BOOST_ASSERT(0);
    return string::Empty;
}

namespace {
    /// ftHgR[hy[WB
    class DefaultEncoding : public Encoding {
        /// std::string֕ϊ
        virtual int GetBytes(const wchar_t* chars, int charCount, char* bytes, int byteCount) const {
            if (charCount <= 0) {
                return 0;
            }
#ifdef Themis_UseStdLocale
            std::string buffer;
            buffer.resize(length * 3); // ꂾΏ[낤BB
            typedef std::codecvt<wchar_t, char, std::mbstate_t> codecvt_t;
            const codecvt_t& cvt = std::use_facet<codecvt_t>(GetLocale());
            std::mbstate_t state;
            const wchar_t* next = ptr;
            char* outNext = &buffer[0];
            std::codecvt_base::result result = 
                cvt.out(state, ptr, ptr + length, next, outNext, outNext + buffer.size(), outNext);
            BOOST_ASSERT(result == std::codecvt_base::ok); result;
            buffer.resize(outNext - &buffer[0]);
            return buffer;
            // ̂肭ssȂcB
#else
            int n = ::WideCharToMultiByte(CP_ACP, 0, chars, charCount, bytes, byteCount, NULL, NULL);
            BOOST_ASSERT(n != 0);
            return n; // countw肵Ă̂'\0'܂܂ĂȂ͂B
#endif
        }
        /// string֕ϊ
        virtual string GetString(const std::string& bytes, int index, int count) const {
            BOOST_ASSERT(0 <= index && 0 <= count && index + count <= static_cast<int>(bytes.length()));
            if (count <= 0) {
                return string::Empty;
            }
#ifdef Themis_UseStdLocale
            std::auto_ptr<std::wstring> p(new std::wstring());
            std::wstring& buffer = *p;
            buffer.resize(length * 1);
            typedef std::codecvt<wchar_t, char, std::mbstate_t> codecvt_t;
            const codecvt_t& cvt = std::use_facet<codecvt_t>(GetLocale());
            std::mbstate_t state;
            const char* next = ptr;
            wchar_t* outNext = &buffer[0];
            std::codecvt_base::result result = 
                cvt.in(state, ptr, ptr + length, next, outNext, outNext + buffer.size(), outNext);
            BOOST_ASSERT(result == std::codecvt_base::ok); result;
            buffer.resize(outNext - &buffer[0]);
            return p.release();
#else
            // ̂肭ssȂcB
            std::auto_ptr<std::wstring> p(new std::wstring(GetMaxByteCount(count) + 1, L'\0'));
            int n = ::MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, bytes.c_str() + index, count,
                &(*p)[0], static_cast<int>(p->size()));
            BOOST_ASSERT(n != 0);
            return string(p->c_str(), 0, n); // countw肵Ă̂'\0'܂܂ĂȂ͂B
#endif
        }
        virtual int GetMaxByteCount(int charCount) const { return charCount * 2; }
        virtual int GetMaxCharCount(int byteCount) const { return byteCount; }
    };
}

Encoding& Encoding::GetDefault() {
    static DefaultEncoding instance;
    return instance;
}

}
