#include "stdafx.h"
#include "String.h"
#include <boost/algorithm/string.hpp>
#include <boost/iterator/iterator_facade.hpp>
#include <windows.h> // MultiByteToWideChar
#include <stdarg.h>
namespace Themis {

const string string::Empty(L"");

/// FormatBC#݊ł͂Ȃprintf`ŁB
string string::Format(const wchar_t* format, ...) {
    va_list argptr;
    va_start(argptr, format);
    int length = _vscwprintf(format, argptr);
    std::auto_ptr<std::wstring> p(new std::wstring(length + 1, L'\0')); // '\0'̕1m
  #if __STDC_WANT_SECURE_LIB__ // ł񂩁H
    vswprintf_s(&(*p)[0], p->length(), format, argptr);
  #else
    vswprintf(&(*p)[0], format, argptr);
  #endif
    va_end(argptr);
    p->resize(length); // ߂Đݒ
    return p.release();
}

/// UnicodeKsԂ܂B
string string::Normalize(NormalizationForm::T normalizationForm) const {
    BOOST_ASSERT(0 && "");
    return *this;
}

/// ̕UnicodeK`ł邩ǂ܂B
bool string::IsNormalized(NormalizationForm::T normalizationForm) const {
    BOOST_ASSERT(0 && "");
    return true;
}

/// u
string string::Replace(const string& oldValue, const string& newValue) const {
    std::auto_ptr<std::wstring> p(new std::wstring(ToCharArray()));
    boost::algorithm::replace_all(*p, oldValue.ToCharArray(), newValue.ToCharArray());
    return p.release();
}

/// 
List<string> string::Split(const std::vector<wchar_t>& separator, int count, StringSplitOptions::T options) const {
    if (count == 0) return List<string>();
    if (count == 1) return Array(*this);
    BOOST_ASSERT(1 < count);
    List<string> result;
    int last = 0, i;
    while (0 <= (i = IndexOfAny(separator, last))) {
        if (last != i || options != StringSplitOptions::RemoveEmptyEntries) {
            result.Add(Substring(last, i - last));
        }
        last = i + 1;
        // ^ɂȂ炨I
        if (count <= result.GetCount() + 1) {
            break;
        }
    }
    if (last != GetLength() || options != StringSplitOptions::RemoveEmptyEntries) {
        result.Add(Substring(last));
    }
    return result;
}

/// 
List<string> string::Split(const std::vector<string>& separator, int count, StringSplitOptions::T options) const {
    if (count == 0) return List<string>();
    if (count == 1) return Array(*this);
    BOOST_ASSERT(1 < count);
    List<string> result;
    int last = 0;
    for (int i = 0, n = GetLength(); i < n; ) {
        size_t j = 0;
        for (; j < separator.size(); j++) {
            if (Compare(*this, i, separator[j], 0, separator[j].GetLength(), StringComparison::CurrentCulture) == 0) {
                goto Matched;
            }
        }
        // vȂ
        i++;
        continue;

    Matched:
        // v
        if (i != last || options != StringSplitOptions::RemoveEmptyEntries) {
            result.Add(Substring(last, i - last));
        }
        // separator̎̈ʒu
        i += separator[j].GetLength();
        last = i;
        // ^ɂȂ炨I
        if (count <= result.GetCount() + 1) {
            break;
        }
    }
    if (last != GetLength() || options != StringSplitOptions::RemoveEmptyEntries) {
        result.Add(Substring(last));
    }
    return result;
}

/// separatorŘA
string string::Join(const string& separator, const std::vector<string>& value, int startIndex, int count) {
    BOOST_ASSERT(0 <= startIndex && 0 <= count && startIndex + count <= static_cast<int>(value.size()));
    if (count <= 0) {
        return string::Empty;
    }
    std::auto_ptr<std::wstring> p(new std::wstring());
    *p += value[startIndex].ToCharArray();
    for (int i = 0 + 1; i < count; i++) {
        *p += separator.ToCharArray();
        *p += value[startIndex + i].ToCharArray();
    }
    return p.release();
}

namespace {
    /// Trimn֐pfanctor̂P
    struct IsWhiteSpaceForTrim {
        inline bool operator()(wchar_t c) {
            return Char::IsWhiteSpace(c);
        }
    };
    /// Trimn֐pfanctor̂Q
    struct IsMatchCharsForTrim {
        const std::vector<wchar_t>& list;
        inline IsMatchCharsForTrim(const std::vector<wchar_t>& list) : list(list) {}
        inline bool operator()(wchar_t c) {
            return std::find(list.begin(), list.end(), c) != list.end();
        }
    };
}
string string::Trim() const {
    std::auto_ptr<std::wstring> p(new std::wstring(ToCharArray()));
    boost::algorithm::trim_if(*p, IsWhiteSpaceForTrim());
    return p.release();
}
string string::Trim(const std::vector<wchar_t>& trimChars) const {
    std::auto_ptr<std::wstring> p(new std::wstring(ToCharArray()));
    boost::algorithm::trim_if(*p, IsMatchCharsForTrim(trimChars));
    return p.release();
}
string string::TrimStart() const {
    std::auto_ptr<std::wstring> p(new std::wstring(ToCharArray()));
    boost::algorithm::trim_left_if(*p, IsWhiteSpaceForTrim());
    return p.release();
}
string string::TrimStart(const std::vector<wchar_t>& trimChars) const {
    std::auto_ptr<std::wstring> p(new std::wstring(ToCharArray()));
    boost::algorithm::trim_left_if(*p, IsMatchCharsForTrim(trimChars));
    return p.release();
}
string string::TrimEnd() const {
    std::auto_ptr<std::wstring> p(new std::wstring(ToCharArray()));
    boost::algorithm::trim_right_if(*p, IsWhiteSpaceForTrim());
    return p.release();
}
string string::TrimEnd(const std::vector<wchar_t>& trimChars) const {
    std::auto_ptr<std::wstring> p(new std::wstring(ToCharArray()));
    boost::algorithm::trim_right_if(*p, IsMatchCharsForTrim(trimChars));
    return p.release();
}

}
