#include "stdafx.h"
#include "TrayIcon.h"
#include "Window.h"
#include "Utility/Algorithm.h"
#include "Utility/StringUtility.h"
#include <shellapi.h>
#pragma comment(lib, "shell32.lib")
namespace Themis {

CTrayIcon::CTrayIcon(HWND hWnd, UINT uCallbackMsg): m_hWnd(hWnd), m_pNotifyData(NULL), m_bShow(false) {
    m_pNotifyData = operator new(sizeof(NOTIFYICONDATA));
    memset(m_pNotifyData, 0x00, sizeof(NOTIFYICONDATA));
    static_cast<NOTIFYICONDATA*>(m_pNotifyData)->cbSize = sizeof(NOTIFYICONDATA);
    static_cast<NOTIFYICONDATA*>(m_pNotifyData)->hWnd = m_hWnd;
    static_cast<NOTIFYICONDATA*>(m_pNotifyData)->uID =
        static_cast<UINT>(reinterpret_cast<uintptr_t>(this) ^ 0x1d3fa574);
        // mFpӖȂID
    static_cast<NOTIFYICONDATA*>(m_pNotifyData)->uFlags = NIF_MESSAGE | NIF_TIP | NIF_ICON;  //bZ[Wƃc[`bvƃACR
    static_cast<NOTIFYICONDATA*>(m_pNotifyData)->uCallbackMessage = uCallbackMsg;

    UINT& nTaskbarCreated = GetTaskbarCreated();
    if (nTaskbarCreated == WM_NULL) {
        nTaskbarCreated = ::RegisterWindowMessage("TaskbarCreated");
    }
}

CTrayIcon::~CTrayIcon() {
    UnsetIcon();
    operator delete(m_pNotifyData);
}


bool CTrayIcon::SetIcon(int nId) {
    return SetIcon(::LoadIcon(::GetModuleHandle(NULL), MAKEINTRESOURCE(nId)));
}

bool CTrayIcon::SetIcon(HICON hIcon) {
    static_cast<NOTIFYICONDATA*>(m_pNotifyData)->hIcon = hIcon;
    return NotifyIcon(IsShow() ? NIM_MODIFY : NIM_ADD);
}

void CTrayIcon::UnsetIcon() {
    if (IsShow()) {
        NotifyIcon(NIM_DELETE);
    }
}

bool CTrayIcon::SetTip(const string& msg) {
    StrCopy(static_cast<NOTIFYICONDATA*>(m_pNotifyData)->szTip, 
        lengthof(static_cast<NOTIFYICONDATA*>(m_pNotifyData)->szTip), msg);
    if (IsShow()) {  // ɕ\ĂƂB
        return NotifyIcon(NIM_MODIFY);
    }
    return true;    // Ƃ肠ƂɂႤB
}

bool CTrayIcon::NotifyIcon(DWORD dwMessage) {
    BOOL ret = ::Shell_NotifyIcon(dwMessage, static_cast<NOTIFYICONDATA*>(m_pNotifyData));
    if (ret == FALSE) {
        return false;
    }
    m_bShow = (dwMessage != NIM_DELETE);
    return true;
}

bool CTrayIcon::OnTaskbarCreate(CMsgHookPrms& rPrms) {
    if (rPrms.GetMsg() == GetTaskbarCreated()) {
        if (IsShow()) {
            NotifyIcon(NIM_ADD); //NIM_MODIFYH
        }
        return true;
    }
    return false;
}

UINT& CTrayIcon::GetTaskbarCreated() {
    static UINT s_nTaskbarCreated = WM_NULL;
    return s_nTaskbarCreated;
}

}
