#include "stdafx.h"
#include "StringUtility.h"
#include "../String/StringBuilder.h"
#include "../String/Encoding.h"
namespace Themis {

string ItoA(int i) {
    return string::Format(L"%d", i);
}

string FtoA(double d) {
    string str = string::Format(L"%.4f", d); // őSƂĂBȂ񂩉͌̕\덷BB
    int t = str.GetLength() - 1;
    while (str[t] == L'0') {
        t--;
    }
    return str.Substring(0, t + (str[t] == L'.' ? 2 : 1));
}

int AtoI(const string& str) {
    return atoi(Encoding::GetDefault().GetBytes(str).c_str());
}

double AtoF(const string& str) {
    return atof(Encoding::GetDefault().GetBytes(str).c_str());
}

void StrCopy(char* psz, size_t length, const string& src) {
    Themis_DebugAssert(0 < length);
    std::string str = Encoding::GetDefault().GetBytes(src);
    if (str.length() + 1 <= length) {
        memcpy(psz, str.c_str(), str.length() + 1);
    } else {
        memcpy(psz, str.c_str(), length - 2);
        psz[length - 1] = L'\0';
    }
}

char* ToMultiByteChars(const string& str) {
    std::string mb = Encoding::GetDefault().GetBytes(str);
    int n = static_cast<int>(mb.length()) + 1;
    char* sz = new char[n];
    memcpy(sz, mb.c_str(), n);
    return sz;
}

string BinToHex(const vector<uint8_t>& vctBin) {
    const wchar_t* const c_pszHex = L"0123456789abcdef";
    StringBuilder result;
    for (size_t i = 0, n = vctBin.size(); i < n; i++) {
        const uint32_t t = vctBin[i];
        result.Append(c_pszHex[(t >> 4) & 0x0F]);
        result.Append(c_pszHex[t & 0x0F]);
    }
    return result.ToString();
}

string BinToBase64(const vector<uint8_t>& vctBin) {
    const wchar_t* const c_pszBase64 = L"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    StringBuilder result;
    const size_t nMod = vctBin.size() % 3;
    size_t i = 0, n = vctBin.size() - nMod;
    for (; i < n; i += 3) {
        result.Append(c_pszBase64[((vctBin[i + 0] >> 2)) & 0x3F]);    // 6
        result.Append(c_pszBase64[((vctBin[i + 0] << 4) | (vctBin[i + 1] >> 4)) & 0x3F]); // 2 + 4
        result.Append(c_pszBase64[((vctBin[i + 1] << 2) | (vctBin[i + 2] >> 6)) & 0x3F]); // 4 + 2
        result.Append(c_pszBase64[vctBin[i + 2] & 0x3F]); // 6
    }
    switch (nMod) {
    case 0:
        break;
    case 1:
        result.Append(c_pszBase64[((vctBin[i + 0] >> 2)) & 0x3F]); // 6
        result.Append(c_pszBase64[((vctBin[i + 0] << 4)) & 0x3F]); // 2 + 4
        result.Append(L"=");
        result.Append(L"=");
        break;
    case 2:
        result.Append(c_pszBase64[((vctBin[i + 0] >> 2)) & 0x3F]);    // 6
        result.Append(c_pszBase64[((vctBin[i + 0] << 4) | (vctBin[i + 1] >> 4)) & 0x3F]); // 2 + 4
        result.Append(c_pszBase64[((vctBin[i + 1] << 2)) & 0x3F]); // 4 + 2
        result.Append(L"=");
        break;
    default:
        Themis_DebugTrespass();
    }
    return result.ToString();
}

namespace {
    inline int HexToInt(wchar_t c) {
        if (Char::IsDigit(c)) { return c - L'0' + 0x0; }
        if (Char::IsLower(c)) { return c - L'a' + 0x0a; }
        if (Char::IsUpper(c)) { return c - L'A' + 0x0a; }
        return -1;
    }
}
vector<uint8_t> HexToBin(const string& strHex) {
    vector<uint8_t> vct;
    uint32_t t = 0;
    int nFlag = 0;
    for (int i = 0, n = strHex.GetLength(); i < n; i++) {
        int c = HexToInt(strHex[i]);
        if (0 <= c) {
            if (nFlag != 0) {
                vct.push_back(uint8_t((t << 4) | c));
            } else {
                t = c;
            }
            nFlag = !nFlag;
        } else {
            // 䕶͖
        }
    }
    return vct;
}

namespace {
    inline int Base64ToInt(wchar_t c) {
        if (Char::IsUpper(c)) { return c - L'A' + 0; }
        if (Char::IsLower(c)) { return c - L'a' + 26; }
        if (Char::IsDigit(c)) { return c - L'0' + 52; }
        switch (c) {
        case L'+': return 62;
        case L'/': return 63;
        case L'=': return -1;
        default: return -2;
        }
    }
    void AddBinByBase64(vector<uint8_t>& vct, uint32_t t[4]) {
        vct.push_back(uint8_t((t[0] << 2) | (t[1] >> 4)));
        vct.push_back(uint8_t((t[1] << 4) | (t[2] >> 2)));
        vct.push_back(uint8_t((t[2] << 6) | (t[3] >> 0)));
    }
}
vector<uint8_t> Base64ToBin(const string& strBase64) {
    vector<uint8_t> vct;
    uint32_t t[4] = {0};
    int nFlag = 0;
    for (int i = 0, n = strBase64.GetLength(); i < n; i++) {
        int c = Base64ToInt(strBase64[i]);
        if (0 <= c) {
            switch (nFlag) {
            case 0: t[nFlag] = c; nFlag++; break;
            case 1: t[nFlag] = c; nFlag++; break;
            case 2: t[nFlag] = c; nFlag++; break;
            case 3:
                t[nFlag] = c;
                AddBinByBase64(vct, t);
                nFlag = 0;
                break;
            default:
                Themis_DebugTrespass();
            }
        } else if (c == -1) { // L'='
            if (nFlag <= 2) {
                vct.push_back(uint8_t((t[0] << 2) | (t[1] >> 4)));
            } else {
                vct.push_back(uint8_t((t[0] << 2) | (t[1] >> 4)));
                vct.push_back(uint8_t((t[1] << 4) | (t[2] >> 2)));
            }
            break;
        } else {
            // 䕶͖
        }
    }
    return vct;
}

string Replace(const string& str, vector<pair<string, string> >& vct) {
    StringBuilder builder(str);
    for (size_t i = 0, n = vct.size(); i < n; i++) {
        builder.Replace(vct[i].first, vct[i].second);
    }
    return builder.ToString();
}

string Replace(const string& str, vector<pair<wchar_t, wchar_t> >& vct) {
    StringBuilder builder(str);
    for (size_t i = 0, n = vct.size(); i < n; i++) {
        builder.Replace(vct[i].first, vct[i].second);
    }
    return builder.ToString();
}

}
