#pragma once
#include "SerializeBase.h"
#include "Utility/StringUtility.h"
namespace Themis {

/**
    ϐEꎞϐP\IuWFNgB

    TypéA-1:`A0:A1:lA2:B
    gƂɂ܂߂ɒׂׂB

    l͕lƕցAl͐lƕֈÖق̕ϊsB
    A񂩂琔lւ̕ϊ͖B
*/
class CVariable: public ISerializable {
public:
    CVariable(): m_nType(-1) {}
    CVariable(int i) { CVariable::operator=(i); }
    CVariable(double f) { CVariable::operator=(f); }
    CVariable(const string& s) { CVariable::operator=(s); }

    /// f[^̎ނ̎擾
    int GetType() const { return m_nType; }
    /// Ȃ̂ǂ
    bool IsStr() const { return GetType() == 2; }
    /// lA܂͕lȂ̂ǂ
    bool IsNum() const { return GetType() != 2; }

    /// lA܂͕l̏_ȉ؂̂Ăł̐
    int GetInt() const { Themis_DebugAssert(IsNum()); return static_cast<int>(m_dValue); }
    /// lA܂͕l
    double GetFloat() const { Themis_DebugAssert(IsNum()); return m_dValue; }
    /// ̒ڎ擾
    string GetStr() const { Themis_DebugAssert(IsStr()); return m_strValue; }

    /// ^UlƂĎ擾
    bool GetAsBool() const {
        switch (GetType()) {
        case 0: return GetInt() != 0;
        case 1: return GetFloat() != 0.0;   //RĂł񂾂납cH
        case 2: return !string::IsNullOrEmpty(GetStr());
        default: Themis_DebugTrespass(); return false;
        }
    }
    /// ƂĎ擾(l^̏ꍇ͕ϊ)
    string GetAsStr() const {
        switch (GetType()) {
        case 0: return ItoA(static_cast<int>(m_dValue));
        case 1: return FtoA(m_dValue);
        case 2: return m_strValue;
        default: Themis_DebugTrespass(); return string::Empty;
        }
    }

    CVariable& operator=(int i) { m_nType = 0; m_dValue = static_cast<double>(i); return *this; }
    CVariable& operator=(double f) { m_nType = 1; m_dValue = f; return *this; }
    CVariable& operator=(const string& s) { m_nType = 2; m_strValue = s; return *this; }

private:
    void OnSerialize(ISerializer& r) const {
        r << m_nType;
        if (IsNum()) {
            r << m_dValue;
        } else {
            r << m_strValue;
        }
    }
    void OnRestore(IRestorer& r) {
        r << m_nType;
        if (IsNum()) {
            r << m_dValue;
        } else {
            r << m_strValue;
        }
    }

    int         m_nType;
    double      m_dValue;
    string      m_strValue;
};

//////////////////////////////////////////////////////////////////////

/**
    ֐̃p[^[ȂǂɎǵׂAϐIuWFNg̔zB

    CVariable͌^`FbNʓ|Ȃ̂ŁACheckTypeŏyɁB
*/
class CVariableArray {
public:
    void Add(const CVariable& r) { m_vct.push_back(r); }
    int GetCount() const { return static_cast<int>(m_vct.size()); }

    bool CheckType() const {
        return GetCount() == 0;
    }
    bool CheckType(bool bStr1) const {
        return GetCount() == 1 && IsStr(0) == bStr1;
    }
    bool CheckType(bool bStr1, bool bStr2) const {
        return GetCount() == 2 && IsStr(0) == bStr1 && IsStr(1) == bStr2;
    }
    bool CheckType(bool bStr1, bool bStr2, bool bStr3) const {
        return GetCount() == 3 && IsStr(0) == bStr1 && IsStr(1) == bStr2 && IsStr(2) == bStr3;
    }
    bool CheckType(bool bStr1, bool bStr2, bool bStr3, bool bStr4) const {
        return GetCount() == 4 && IsStr(0) == bStr1 && IsStr(1) == bStr2 && IsStr(2) == bStr3 && IsStr(3) == bStr4;
    }

    int GetType(int n) const { return Get(n).GetType(); }
    bool IsStr(int n) const { return Get(n).IsStr(); }
    bool IsNum(int n) const { return Get(n).IsNum(); }
    int GetInt(int n) const { return Get(n).GetInt(); }
    double GetFloat(int n) const { return Get(n).GetFloat(); }
    string GetStr(int n) const { return Get(n).GetStr(); }

    const CVariable& Get(int n) const { return m_vct[n]; }

private:
    vector<CVariable>  m_vct;
};

}
