#pragma once
#include "../String/Encoding.h"
namespace Themis {

/// DLL܂łO
class DllNotFoundException : public Win32Exception {
public:
    DllNotFoundException(const string& str) : Win32Exception(str) {}
};

/// DLL܂łO
class EntryPointNotFoundException : public Win32Exception {
public:
    EntryPointNotFoundException(const string& str) : Win32Exception(str) {}
};

/// 0̊֐pev[gNX
template<class R> struct CDllFunc0 { typedef R (WINAPI* T)(); };
/// 1̊֐pev[gNX
template<class R, class A> struct CDllFunc1 { typedef R (WINAPI* T)(A); };
/// 2̊֐pev[gNX
template<class R, class A, class B> struct CDllFunc2 { typedef R (WINAPI* T)(A, B); };
/// 3̊֐pev[gNX
template<class R, class A, class B, class C> struct CDllFunc3 { typedef R (WINAPI* T)(A, B, C); };
/// 4̊֐pev[gNX
template<class R, class A, class B, class C, class D> struct CDllFunc4 { typedef R (WINAPI* T)(A, B, C, D); };
/// 5̊֐pev[gNX
template<class R, class A, class B, class C, class D, class E> struct CDllFunc5 { typedef R (WINAPI* T)(A, B, C, D, E); };

/**
    DLL֌W̊֐bsO

    dll.dll  int func(short, long, char)
    ĂяoƂA
    CDll oDll(L"dll.dll");
    int int_value = oDll(L"func", CDllFunc3<int, short, long, char>())(short_value, long_value, char_value);
    Əo悤ɂĂ݂B

    int int_value = oDll.GetProc3<int, short, long, char>(L"func")(short_value, long_value, char_value);
    Ƃΐ\Ȃ񂾂ǂȂcB
    int int_value = oDll(CDllFunc3<int, short, long, char>(L"func"))(short_value, long_value, char_value);
    ƂƃJ}āAꌩӖsȁu()vȂ邯ǁACDllFunc֐̂wcB

    CDllFunc͌ĂяoKWINAPIɂĂ̂ŁAȊǑĂяoK̂̂̏ꍇGetProcOŃLXgׂB
*/
class CDll : private boost::noncopyable {
public:
    CDll(const string& strFileName, bool bLoadOwn = true) : m_strFileName(strFileName) {
        m_bLoadOwn = bLoadOwn;
        m_hDll = bLoadOwn ?
            ::LoadLibrary(Encoding::GetDefault().GetBytes(m_strFileName).c_str()) :
            ::GetModuleHandle(Encoding::GetDefault().GetBytes(m_strFileName).c_str());
        if (m_hDll == NULL) {
            throw DllNotFoundException(m_strFileName + L"̃[hɎs");
        }
    }
    ~CDll() {
        if (m_hDll != NULL && m_bLoadOwn) {
            ::FreeLibrary(m_hDll);
            m_hDll = NULL;
        }
    }

    //@{ ֐AhX̎擾
    void* GetProc(const string& strProcName) const {
        void* p = ::GetProcAddress(m_hDll, Encoding::GetDefault().GetBytes(strProcName).c_str());
        if (p == NULL) {
            throw EntryPointNotFoundException(m_strFileName + L" '" + strProcName + L"' ̎擾Ɏs");
        }
        return p;
    }
    void* GetProcNoThrow(const string& strProcName) const {
        return ::GetProcAddress(m_hDll, Encoding::GetDefault().GetBytes(strProcName).c_str());
    }
    //@}

    /// 0̊֐|C^擾
    template<class R> typename CDllFunc0<R>::T operator()(const string& str, CDllFunc0<R>) const { return static_cast<typename CDllFunc0<R>::T>(GetProc(str)); }
    /// 1̊֐|C^擾
    template<class R, class A> typename CDllFunc1<R, A>::T operator()(const string& str, CDllFunc1<R, A>) const { return static_cast<typename CDllFunc1<R, A>::T>(GetProc(str)); }
    /// 2̊֐|C^擾
    template<class R, class A, class B> typename CDllFunc2<R, A, B>::T operator()(const string& str, CDllFunc2<R, A, B>) const { return static_cast<typename CDllFunc2<R, A, B>::T>(GetProc(str)); }
    /// 3̊֐|C^擾
    template<class R, class A, class B, class C> typename CDllFunc3<R, A, B, C>::T operator()(const string& str, CDllFunc3<R, A, B, C>) const { return static_cast<typename CDllFunc3<R, A, B, C>::T>(GetProc(str)); }
    /// 4̊֐|C^擾
    template<class R, class A, class B, class C, class D> typename CDllFunc4<R, A, B, C, D>::T operator()(const string& str, CDllFunc4<R, A, B, C, D>) const { return static_cast<typename CDllFunc4<R, A, B, C, D>::T>(GetProc(str)); }
    /// 5̊֐|C^擾
    template<class R, class A, class B, class C, class D, class E> typename CDllFunc5<R, A, B, C, D, E>::T operator()(const string& str, CDllFunc5<R, A, B, C, D, E>) const { return static_cast<typename CDllFunc5<R, A, B, C, D, E>::T>(GetProc(str)); }

    /// t@C̎擾(̔qɎgȂ̂)
    const string& GetFileName() const { return m_strFileName; }
    /// nh̎擾(gȂƎvǔÔ)
    HMODULE GetHandle() const { return m_hDll; }

private:
    string      m_strFileName;
    HMODULE     m_hDll;
    bool        m_bLoadOwn;
};

}
