#pragma once
#include "DialogResult.h"
#include "../Property.h"
namespace Themis {

/**
 * CommonDialog̊NX
 */
class CommonDialog : private boost::noncopyable {
public:
    //object Tag { get; set; }
    //event EventHandler HelpRequest;

    //protected virtual HWND HookProc(HWND hWnd, int msg, HWND wparam, HWND lparam);
    //protected virtual void OnHelpRequest(EventArgs e);
    //protected virtual HWND OwnerWndProc(HWND hWnd, int msg, HWND wparam, HWND lparam);

    /// _CAO {bNX̃IvVׂĊlɃZbg܂B
    virtual void Reset() = 0;

    /// _CAO̕\
    DialogResult::T ShowDialog() {
        return ShowDialog(NULL);
    }
    /// _CAO̕\
    DialogResult::T ShowDialog(HWND owner) {
        return RunDialog(owner) ? DialogResult::OK : DialogResult::Cancel;
    }

protected:
    virtual bool RunDialog(HWND hwndOwner) = 0;
};

/**
 * t@CJ_CAOƃt@Cۑ邼_CAŐʕ̎
 */
class FileDialog : public CommonDialog {
    bool addExtension;
    bool checkFileExists;
    bool checkPathExists;
    bool dereferenceLinks;
    bool restoreDirectory;
    bool showHelp;
    bool supportMultiDottedExtensions;
    bool validateNames;
    string defaultExt;
    List<string> fileNames;
    string filter;
    string initialDirectory;
    string title;
    int filterIndex;
public:
    FileDialog() {}

    Themis_PropertyGetSetBool(AddExtension, addExtension);
    Themis_PropertyGetSetBool(CheckFileExists, checkFileExists);
    Themis_PropertyGetSetBool(CheckPathExists, checkPathExists);
    Themis_PropertyGetSetBool(DereferenceLinks, dereferenceLinks);
    Themis_PropertyGetSet(string, DefaultExt, defaultExt);
    Themis_PropertyGetSet(string, FileName, fileNames[0]);
    Themis_PropertyGet(List<string>, FileNames, fileNames);
    Themis_PropertyGetSet(string, Filter, filter);
    Themis_PropertyGetSet(int, FilterIndex, filterIndex);
    Themis_PropertyGetSet(string, InitialDirectory, initialDirectory);
    Themis_PropertyGetSetBool(RestoreDirectory, restoreDirectory);
    Themis_PropertyGetSetBool(ShowHelp, showHelp);
    Themis_PropertyGetSetBool(SupportMultiDottedExtensions, supportMultiDottedExtensions);
    Themis_PropertyGetSet(string, Title, title);
    Themis_PropertyGetSetBool(ValidateNames, validateNames);

    //event CancelEventHandler FileOk;

    virtual void Reset() {
        addExtension = true;
        checkFileExists = false;
        checkPathExists = true;
        dereferenceLinks = true;
        fileNames = Array(string::Empty);
        filterIndex = 1;
        restoreDirectory = false;
        showHelp = false;
        supportMultiDottedExtensions = false;
        validateNames = true;
    }

    //override string ToString();

protected:
    //protected virtual HWND Instance { get; }
    //protected int Options { get; }
    //protected override HWND HookProc(HWND hWnd, int msg, HWND wparam, HWND lparam);
    //protected void OnFileOk(CancelEventArgs e);
    //static readonly object EventFileOk;
    bool RunDialog(HWND hWndOwner);
    virtual bool InnerRunDialog() = 0;
};

/// t@CJ_CAO
class OpenFileDialog : public FileDialog {
    bool multiselect;
    bool showReadOnly, readOnlyChecked;
public:
    OpenFileDialog() { Reset(); }

    Themis_PropertyGetSetBool(Multiselect, multiselect);
    Themis_PropertyGetSetBool(ShowReadOnly, showReadOnly);
    Themis_PropertyGetSetBool(ReadOnlyChecked, readOnlyChecked);

 // Stream OpenFile();

    /// _CAO {bNX̃IvVׂĊlɃZbg܂B
    virtual void Reset() {
        FileDialog::Reset();
        multiselect = false;
        readOnlyChecked = false;
        showReadOnly = false;
        SetCheckFileExists(true);
    }

protected:
    bool InnerRunDialog();
};

/// t@Cۑ邼_CAO
class SaveFileDialog : public FileDialog {
    bool createPrompt;
    bool overwritePrompt;
public:
    SaveFileDialog() { Reset(); }

    Themis_PropertyGetSetBool(CreatePrompt, createPrompt);
    Themis_PropertyGetSetBool(OverwritePrompt, overwritePrompt);

 // Stream OpenFile();

    /// _CAO {bNX̃IvVׂĊlɃZbg܂B
    virtual void Reset() {
        FileDialog::Reset();
        createPrompt = false;
        overwritePrompt = true;
    }

protected:
    bool InnerRunDialog();
};

}
