#pragma once
namespace Themis {

/** Ƃ̎ށB
    CWnd::GetCtrlType()ƂŎĝA
    #include̊֌Włɒ` (;L`)
*/
enum EWndCtrlType {
    eWndCtrlTypeNull = -1,     // G[ȏꍇ
    eWndCtrlTypeButton = 0,
 // eWndCtrlTypeCheckbox = eWndCtrlTypeButton,
 // eWndCtrlTypeRadio = eWndCtrlTypeCheckbox,
    eWndCtrlTypeEditbox,
    eWndCtrlTypeStatic,
    eWndCtrlTypeListbox,
    eWndCtrlTypeCombobox,
    eWndCtrlTypeUpdown,
    eWndCtrlTypeSlider,
    eWndCtrlTypeProgress,
    eWndCtrlTypeListview,
};


/**
    _CAOɓ\tRg[
    삷邽߂̃NX̊NXB

    ܂Ŏpׂ̕Ȃ̂ŁAfXgN^virtual͖ŁB
*/
class CCtrl {
public:
    CCtrl(HWND hWnd) : m_hWnd(hWnd) {}
    ~CCtrl() {}

    bool Exists();
    DWORD GetStyle();
    DWORD GetExStyle();
    CRect GetRect();
    CPoint GetPos();
    CSize GetSize();
    CRect GetClientRect();
    CPoint GetClientPos();
    CSize GetClientSize();
    bool IsEnabled();
    bool IsVisible();
    bool IsVisibleHScroll() const;
    bool IsVisibleVScroll() const;
    CSize GetValidClientSize() const;
    void SetStyle(DWORD dw);
    void SetExStyle(DWORD dw);
    void SetRect(const CRect& rc);
    void SetPos(const CPoint& pt);
    void SetSize(const CSize& sz);
    void SetClientSize(const CSize& sz);
    void SetEnable(bool b);
    void ReverseEnabled();
    void Show(int n = SW_SHOWNORMAL);
    void Hide();
    void SetFocus();
    void Update();
    void PostUpdate();

    string GetText() const;
    void SetText(const string& text);
    int GetInt() const;
    void SetInt(int n);

    LRESULT SendMsg(UINT u, WPARAM w, LPARAM l) const;
    void PostMsg(UINT u, WPARAM w, LPARAM l) const;
    HWND GetHandle() const { return m_hWnd; }

protected:
    /// Assertp
    EWndCtrlType GetCtrlType() const;

private:
    HWND    m_hWnd;
};

/// {^IuWFNg
class CButton : public CCtrl {
public:
    CButton(HWND hWnd) : CCtrl(hWnd) { Themis_DebugAssert(GetCtrlType() == eWndCtrlTypeButton); }
};

/// `FbN{bNX
class CCheckbox : public CCtrl {
public:
    CCheckbox(HWND hWnd) : CCtrl(hWnd) { Themis_DebugAssert(GetCtrlType() == eWndCtrlTypeButton); }
    /// `FbNĂ̂
    bool GetCheck() const;
    /// `FbNO
    void SetCheck(bool b);
    /// `FbNԂ𔽓]
    void ReverseChecked() { SetCheck(!GetCheck()); }
};

/// GfBbg{bNX
class CEditbox : public CCtrl {
public:
    CEditbox(HWND hWnd) : CCtrl(hWnd) { Themis_DebugAssert(GetCtrlType() == eWndCtrlTypeEditbox); }
    /// Ȃtrue
    bool IsEmpty() const;
    /// ύXĂtrue
    bool IsModified() const;
    /// ύXĂ邩ǂtO蓮ݒ
    CEditbox& SetModified(bool b);
    /// pX[hȓ͗ɂ߂
    CEditbox& SetPasswordMode(bool b);
    /// IʒuɕǉB
    CEditbox& InsertText(const string& strText);
    /// I͈͂ݒ
    CEditbox& SetSelected(int nBegin, int nEnd);
};

/// X^eBbNeLXg
class CStatic : public CCtrl {
public:
    CStatic(HWND hWnd) : CCtrl(hWnd) { Themis_DebugAssert(GetCtrlType() == eWndCtrlTypeStatic); }
};

/// Xg{bNX
class CListbox : public CCtrl {
public:
    CListbox(HWND hWnd) : CCtrl(hWnd) { Themis_DebugAssert(GetCtrlType() == eWndCtrlTypeListbox); }
    /// w荀ڂ̕擾
    string Get(int n) const;
    /// IĂ鍀ڂ̕擾
    string Get() const;
    /// ڑSĂ擾
    vector<string> GetAll() const;
    /// ڂ̐擾
    int GetCount() const;
    /// Ԗڂ̍ڂIĂ̂
    int GetSelected() const;
    /// ڂ𖖔֒ǉ
    CListbox& Add(const string& sz);
    /// ڂ𖖔֒ǉ
    CListbox& Add(const vector<string>& v);
    /// ڂǉ
    CListbox& Insert(int n, const string& sz);
    /// ڂ폜
    CListbox& Delete(int n);
    /// ݂̍ڂ폜
    CListbox& Delete();
    /// ڂSč폜
    CListbox& Clear();
    /// nIndexԖڂ̍ڂI
    CListbox& SetSelected(int nIndex);
    /// strȍڂIB蓮ŏȂ̂ł傢d߁B
    CListbox& SetSelected(const string& str);
    /// ďԂBȂ-1
    int Find(const string& str) const;
    /// ڂɈړ(ړłtrue)
    bool Up(int nIndex, bool bSelect = true);
    /// ڂɈړ(ړłtrue)
    bool Down(int nIndex, bool bSelect = true);
};

/// R{{bNX
class CCombobox : public CCtrl {
public:
    CCombobox(HWND hWnd) : CCtrl(hWnd) { Themis_DebugAssert(GetCtrlType() == eWndCtrlTypeCombobox); }
    /// w荀ڂ̕擾
    string Get(int n) const;
    /// Iڂ̕擾
    string Get() const;
    /// ڑSĂ擾
    vector<string> GetAll() const;
    /// ڂ̌擾
    int GetCount() const;
    /// Ԗڂ̍ڂIĂ̂
    int GetSelected() const;
    /// ڂSč폜
    CCombobox& Clear();
    /// ڂ𖖔֒ǉ
    CCombobox& Add(const string& str);
    /// ڂ𖖔֒ǉ
    CCombobox& Add(const vector<string>& v);
    /// ڂ̒ǉ
    CCombobox& Insert(int nIndex, const string& str);
    /// ڂ̍폜
    CCombobox& Delete(int nIndex);
    /// ݂̍ڂ폜
    CCombobox& Delete() { return Delete(GetSelected()); }
    /// nIndexԖڂ̍ڂI
    void SetSelected(int nIndex);
    /// strɈv鍀ڂI
    CCombobox& SetSelected(const string& str);
};

/// Abv_E(Xs)
class CUpdown : public CCtrl {
public:
    CUpdown(HWND hWnd) : CCtrl(hWnd) { Themis_DebugAssert(GetCtrlType() == eWndCtrlTypeUpdown); }
    /// ʒu̎擾
    int Get() const;
    /// ֘AtRg[w
    CUpdown& SetBuddy(HWND hWnd);
    /// lݒ
    CUpdown& SetRange(int nMin, int nMax);
    /// w
    CUpdown& SetStep(int nStep);
    /// lݒ
    void Set(int nPos);
};

/// XC_[
class CSlider : public CCtrl {
public:
    CSlider(HWND hWnd) : CCtrl(hWnd) { Themis_DebugAssert(GetCtrlType() == eWndCtrlTypeSlider); }
    /// ʒu̎擾
    int Get() const;
    /// lݒ
    CSlider& SetRange(int nMin, int nMax);
    /// ڐ̊Ԋu
    CSlider& SetTicFreq(int nFreq);
    /// o[NbNƂ̈ړ
    CSlider& SetPageSize(int nSize);
    /// L[ł̈ړ
    CSlider& SetLineSize(int nSize);
    /// ʒu̐ݒ
    void Set(int n);
};

/// vOXo[
class CProgress : public CCtrl {
public:
    CProgress(HWND hWnd) : CCtrl(hWnd) { Themis_DebugAssert(GetCtrlType() == eWndCtrlTypeProgress); }
    /// lݒ
    CProgress& SetRange(int nMin, int nMax);
    /// PXebv̑
    CProgress& SetStep(int nStep);
    /// PXebvi߂
    CProgress& Step();
    /// ʒu̐ݒ
    CProgress& Set(int n);
};

/// Xgr[
class CListview: public CCtrl {
public:
    CListview(HWND hWnd) : CCtrl(hWnd) { Themis_DebugAssert(GetCtrlType() == eWndCtrlTypeListview); }
    //@{ gX^C
    void SetExListStyle(DWORD dwExStyle);
    void SetExListStyleMasked(DWORD dwExStyle, DWORD dwMask);
    DWORD GetExStyle() const;
    //@}
    //@{ ږ̒ǉEݒE폜E擾E擾
    void RemoveColumn(int nIndex);
    void AddColumn(const string& str, int nWidth, int nPos = 0);
    void AddColumn(int nIndex, const string& str, int nWidth, int nPos = 0);
    void SetColumn(int nIndex, const string& str, int nWidth, int nPos = 0);
    void SetColumnWidth(int nIndex, int nWidth);
    int GetColumnWidth(int nIndex) const;
    string GetColumnText(int nIndex) const;
    int GetColumnCount() const;
    //@}
    //@{ ACR\pImageListݒ
    void SetNormalImageList(void* hImageList);
    void SetSmallImageList(void* hImageList);
    void SetStateImageList(void* hImageList);
    //@}
    //@{ ڂ̒ǉƂݒƂ
    void Clear();
    void AddItems(const vector<string>& vct);
    int AddItem(const string& str, int nIconIndex = -1);
    void AddItem(int nIndex, const string& str, int nIconIndex = -1);
    void SetItem(int nIndex, const string& str) { SetSubItem(nIndex, 0, str); }
    void SetSubItem(int nIndex, int nSubIndex, const string& str);
    void SetIcon(int nIndex, int nIconIndex);
    //@}
    //@{ ڂ̎擾Ƃ
    string GetItemText(int nIndex) const { return GetSubItemText(nIndex, 0); }
    string GetSubItemText(int nIndex, int nSubIndex) const;
    //@}

    // strcmp()Ƃ̖߂lԂ悤ɎB
    // int CALLBACK LVSortCompare(LPARAM nIndex1, LPARAM nIndex2, LPARAM lParamSort);
    typedef int (CALLBACK* FnCompare)(LPARAM nIndex1, LPARAM nIndex2, LPARAM lParamSort);
    /// \[gBLVN_COLUMNCLICKĂԂׂB
    void SortItems(FnCompare fnCompare, LPARAM lParamSort);

    //@{ uvuv̏BWinXPB
    void SetColumnSortUp(int nSubIndex);
    void SetColumnSortDown(int nSubIndex);
    void ResetSetColumnSort(int nSubIndex);
    void ResetSetColumnsSort();
    //@}

    /// ڐ̐ݒBzXgr[pH
    void SetItemCount(int nCount);
    /// ڂ̍XVBzXgr[pۂ
    void UpdateItem(int nItem);
    /// SĂ̍ڂ̍XV
    void UpdateItems();

    /// ڂ̍폜
    void Remove(int nIndex);
    /// ڂ̐̎擾
    int GetCount() const;
    /// nIndexԖڂ̍ڂI
    void SetSelected(int nIndex, bool bSelected = true);
    /// Ԗڂ̍ڂIĂ̂
    int GetSelected() const;
    /// IĂ鍀ڂ̃XgԂ
    vector<int> GetSelectedIndexes() const;
    /// nIndexԖڂ̍ڂIĂ̂ǂ擾
    bool IsSelected(int nIndex);
    /// SĂI
    void SetSelectAll(bool bSelected = true);
    /// SĂ̑I𔽓]
    void ReverseSelectAll();
    /// ISĉ
    void ClearSelect() { SetSelectAll(false); }
    /// IĂƂ܂ŃXN[
    void ScrollToSelect();
    /// IĂƂキ炢ɂȂ悤ɃXN[
    void ScrollToSelectCenter();

    //@{ `FbN{bNXtXgr[ȏ
    void SetCheck(int nIndex, bool bCheck);
    bool GetCheck(int nIndex) const;
    //@}
};

/// WI{^
class CRadios {
public:
    CRadios(HWND hDlg) : m_hDlg(hDlg), m_nDefault(0) {}
    ~CRadios() {}
    CRadios& operator/(int nId);
    CRadios& SetDefault(int nDefault) { m_nDefault = nDefault; return *this; }
    int Get() const;
    void Set(int n);
private:
    HWND                m_hDlg;
    vector<CCheckbox>   m_vctRadios;
    int                 m_nDefault;
};

}
