#pragma once
namespace Themis {

namespace Detail {
    /// 񕪌BƂ肠KɎĂ݂ǂ܂葁ȂB
    class CSearchBinary {
    public:
        template<class C, class T, class Cmp> static pair<bool, int> find(const C& c, const T& x, Cmp less) {
            if (c.empty()) {
                return make_pair(false, 0);
            }
            int l = 1;
            int r = static_cast<int>(c.size());
            while (l < r) {
                int n = (l + r) / 2;
                if (less(c[n], x)) {
                    l = n + 1;
                } else if (less(x, c[n])) {
                    r = n;
                } else {
                    //̂
                    return make_pair(true, n);
                }
            }
            if (less(c[l-1], x)) {
                return make_pair(false, l);
            } else if (less(x, c[l-1])) {
                return make_pair(false, l-1);
            } else {
                return make_pair(true, l-1);
            }
        }
    };
    /// ̏
    class CSearchSequential {
    public:
        template<class C, class T, class Cmp> static pair<bool, int> find(const C& c, const T& x, Cmp less) {
            int i = 0;
            for (int n = static_cast<int>(c.size()); i < n; i++) {
                if (less(c[i], x)) {
                } else if (less(x, c[i])) {
                    break;
                } else {
                    return make_pair(true, i);
                }
            }
            return make_pair(false, i);
        }
    };
};

/**
    std::setۂvectorB

    vfȂƂ{ǂB
*/
template<class T, class F = Detail::CSearchSequential> class set_vector : private boost::noncopyable {
private:
    typedef set_vector<T, F> this_type;

public:
    typedef typename vector<T>::value_type value_type;
    typedef typename vector<T>::size_type size_type;
    typedef typename vector<T>::iterator iterator;
    typedef typename vector<T>::reference reference;
    typedef typename vector<T>::const_iterator const_iterator;
    typedef typename vector<T>::const_reference const_reference;

    set_vector() {}
    ~set_vector() {}

    template<class Cmp> inline iterator find(const_reference x, Cmp cmp) {
        pair<bool, int> p = F::find(m_c, x, cmp);
        return p.first ? begin() + p.second : end();
    }
    inline iterator find(const_reference x) { return find(x, std::less<value_type>()); }

    template<class Cmp> inline bool insert(const_reference x, Cmp cmp) {
        pair<bool, int> p = F::find(m_c, x, cmp);
        if (p.first) { //d͕s
            return false;
        }
        m_c.insert(m_c.begin() + p.second, x);
        return true; //ǉ
    }
    inline bool insert(const_reference x) { return insert(x, std::less<value_type>()); }

    template<class Cmp> inline void multi_insert(const_reference x, Cmp cmp) {
        pair<bool, int> p = F::find(m_c, x, cmp);
        m_c.insert(m_c.begin() + p.second, x);    //dĂĂǉ
    }
    inline void multi_insert(const_reference x) { return multi_insert(x, std::less<value_type>()); }

    template<class Cmp> inline void erase(const_reference x, Cmp cmp) {
        pair<bool, int> p = F::find(m_c, x, cmp);
        if (p.first) {
            m_c.erase(m_c.begin() + p.second);
        }
    }
    inline void erase(const_reference x) { erase(x, std::less<value_type>()); }

    inline void clear() { m_c.clear(); }
    inline bool empty() const { return m_c.empty(); }
    inline size_type size() const { return m_c.size(); }
    inline iterator begin() { return m_c.begin(); }
    inline iterator end() { return m_c.end(); }
    inline const_iterator begin() const { return m_c.begin(); }
    inline const_iterator end() const { return m_c.end(); }
    inline iterator erase(iterator it) { return m_c.erase(it); }
    inline iterator erase(iterator f, iterator l) { return m_c.erase(f, l); }
    inline void pop_front() { m_c.pop_front(); }
    inline void pop_back() { m_c.pop_back(); }
    inline reference operator[](size_type n) { return m_c[n]; }
    inline const_reference operator[](size_type n) const { return m_c[n]; }

private:
    vector<T>   m_c;
};

}
