#pragma once
#include <Themis/Windows/ResourceDialogBase.h>
#include <Themis/Config.h>

class CConfigDialog: public CResourceDialogBase {
public:
    CConfigDialog(CConfig& r);
    ~CConfigDialog();

private:
    bool HookMsg(CMsgHookPrms& rPrms);
    void UpdateEnableCtrl();
    void LoadFromConfig();
    void SaveToConfig();

private:
    CConfig&    m_oConfig;
};

//----------------------------------------------------------------//

class CKeyDialog: public CResourceDialogBase {
public:
    CKeyDialog();
    ~CKeyDialog();

    bool IsOK() const { return m_bOK; }

    void SetKey(const string& str) { m_strKey = str; }
    const string& GetKey() const { return m_strKey; }

private:
    bool HookMsg(CMsgHookPrms& rPrms);

private:
    bool        m_bOK;
    string     m_strKey;
};
